﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Layouts;
using Infragistics.Controls.Layouts.Primitives;
using System.IO;

namespace TileManager
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        double width = 100, height = 250;
        bool allowResize = true, first = false;

        private void tileMgr_Loaded(object sender, RoutedEventArgs e)
        {
            TileConstraints cons;
            int i = 0;
            foreach (object tile in tileMgr.Items)
            {
                cons = new TileConstraints();
                cons.PreferredWidth = width + i;
                cons.PreferredHeight = height;
                Infragistics.Controls.Layouts.XamTileManager.SetConstraints(tile as XamTile, cons);
                i += 100;
            }
            first = true;
        }

        private void tile_Loaded(object sender, RoutedEventArgs e)
        {
            //TileConstraints cons = new TileConstraints();
            //cons.PreferredWidth = (sender as XamTile).ActualWidth + 50;
            //cons.PreferredHeight = (sender as XamTile).ActualHeight + 50;
            //Infragistics.Controls.Layouts.XamTileManager.SetConstraints(sender as XamTile, cons);
        }

        private void XamTile_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (allowResize && first)
            {
                TileConstraints cons = Infragistics.Controls.Layouts.XamTileManager.GetConstraints(sender as DependencyObject);
                if (cons == null) cons = new TileConstraints();
                if ((e.NewSize.Width % width) != 0)
                {
                    cons.PreferredWidth = (((int)e.NewSize.Width / (int)width) + 1) * width;
                }

                if ((e.NewSize.Height % height) != 0)
                {
                    cons.PreferredHeight = height * ((int)e.NewSize.Height / (int)height);
                }
                Infragistics.Controls.Layouts.XamTileManager.SetConstraints(sender as DependencyObject, cons);
            }
            //TileConstraints cons;
            //cons = Infragistics.Controls.Layouts.XamTileManager.GetConstraints(sender as XamTile);
            //if (cons == null) cons = new TileConstraints();
            //cons.PreferredHeight = e.NewSize.Height + 25;
            //cons.PreferredWidth = e.NewSize.Width + 50;
            //Infragistics.Controls.Layouts.XamTileManager.SetConstraints(sender as DependencyObject, cons);
        }

        private void tileMgr_TileStateChanged(object sender, TileStateChangedEventArgs e)
        {
            if (e.NewState != TileState.Normal)
                allowResize = false;
        }
    }
}
